import { type WrapperFactoryProvider } from '@jvalue/jayvee-language-server';
import { type Logger } from '../logging/logger';
import { type Workbook } from '../types';
import { type FileSystem } from '../types/io-types/filesystem';
import { type BinaryFile } from '../types/io-types/filesystem-node-file-binary';
import { type TextFile } from '../types/io-types/filesystem-node-file-text';
import { type IoTypeVisitor } from '../types/io-types/io-type-implementation';
import { type Sheet } from '../types/io-types/sheet';
import { type Table } from '../types/io-types/table';
import { type DebugGranularity } from './debug-configuration';
export declare class DebugLogVisitor implements IoTypeVisitor<void> {
    private debugGranularity;
    private logPrefix;
    private logger;
    private wrapperFactories;
    private readonly PEEK_NUMBER_OF_WORKBOOKS;
    private readonly PEEK_NUMBER_OF_ROWS;
    private readonly PEEK_NUMBER_OF_BYTES;
    private readonly PEEK_NUMBER_OF_LINES;
    constructor(debugGranularity: DebugGranularity, logPrefix: string, logger: Logger, wrapperFactories: WrapperFactoryProvider);
    visitTable(table: Table): void;
    visitSheet(sheet: Sheet): void;
    visitNone(): void;
    visitFileSystem(fileSystem: FileSystem): void;
    visitBinaryFile(binaryFile: BinaryFile): void;
    visitTextFile(binaryFile: TextFile): void;
    private logPeekComment;
    visitWorkbook(workbook: Workbook): void;
    private log;
}
