import { type LangiumDocument } from 'langium';
import { type Range } from 'vscode-languageserver';
import { DefaultLogger } from './default-logger';
import { LogCache } from './log-cache';
import { DiagnosticSeverity, type LogEntry } from './logger';
export declare class CachedLogger extends DefaultLogger {
    protected printLogs: boolean;
    protected logCache: LogCache;
    constructor(enableDebugLogging: boolean, loggingContext?: string, printLogs?: boolean, depth?: number, cacheSize?: number);
    /**
     * Gets all log entries with the specified log levels.
     * If no log level given, returns logs on all log levels.
     */
    getLogs(...logLevel: DiagnosticSeverity[]): readonly LogEntry[];
    clearLogs(): void;
    logInfo(message: string): void;
    logDebug(message: string): void;
    logErr(message: string): void;
    protected logDiagnostic(severity: DiagnosticSeverity, message: string, range: Range, document: LangiumDocument): void;
    printMessageToPrintFnIfEnabled(message: string, printFn: (message: string) => void): void;
}
