import { type LangiumDocument } from 'langium';
import { type Range } from 'vscode-languageserver';
import { DiagnosticSeverity, Logger } from './logger';
export declare class DefaultLogger extends Logger {
    protected readonly enableDebugLogging: boolean;
    protected loggingContext?: string | undefined;
    protected depth: number;
    private readonly TAB_TO_SPACES;
    constructor(enableDebugLogging: boolean, loggingContext?: string | undefined, depth?: number);
    logInfo(message: string): void;
    logDebug(message: string): void;
    logErr(message: string): void;
    setLoggingContext(loggingContext: string | undefined): void;
    setLoggingDepth(depth: number): void;
    private getDepthTabs;
    protected getContext(): string;
    protected logDiagnostic(severity: DiagnosticSeverity, message: string, range: Range, document: LangiumDocument): void;
    protected logDiagnosticMessage(severityName: string, message: string, printFn: (message: string) => void, colorFn: (message: string) => string): void;
    protected logDiagnosticInfo(range: Range, document: LangiumDocument, printFn: (message: string) => void, colorFn: (message: string) => string): void;
    /**
     * Repeats {@link charToRepeat} as many times as {@link accordingTo} is long.
     * For each occurrence of \t in {@link accordingTo},
     * {@link charToRepeat} is repeated {@link tabRepeats} times instead of once.
     */
    private repeatCharAccordingToString;
    protected inferPrintFunction(severity: DiagnosticSeverity): (message: string) => void;
    protected inferChalkColor(severity: DiagnosticSeverity): (message: string) => string;
}
