import { type Logger } from '@jvalue/jayvee-execution';
import { type JayveeServices } from '@jvalue/jayvee-language-server';
import { type AstNode, type LangiumDocument } from 'langium';
import { type LangiumServices } from 'langium/lsp';
export declare enum ExitCode {
    SUCCESS = 0,
    FAILURE = 1
}
/**
 * Extracts a document from a file that contains a model.
 * Does load the directory of this document as the working directory.
 */
export declare function extractDocumentFromFile(filePath: string, services: LangiumServices, logger: Logger): Promise<LangiumDocument>;
/**
 * Extracts a document from a string that contains a model.
 * Does not load an additional working directory.
 */
export declare function extractDocumentFromString(modelString: string, services: JayveeServices, logger: Logger): Promise<LangiumDocument>;
export declare function validateDocument(document: LangiumDocument, services: LangiumServices, logger: Logger): Promise<LangiumDocument>;
export declare function extractAstNodeFromFile<T extends AstNode>(filePath: string, services: JayveeServices, logger: Logger): Promise<T>;
export declare function extractAstNodeFromString<T extends AstNode>(modelString: string, services: JayveeServices, logger: Logger): Promise<T>;
