import { type ValidationContext } from '../../validation';
import { type Expression, type PropertyAssignment } from '../generated/ast';
import { type ValueType, type WrapperFactoryProvider } from '../wrappers';
import { type EvaluationContext } from './evaluation-context';
import { EvaluationStrategy } from './evaluation-strategy';
import { type InternalValueRepresentation } from './internal-value-representation';
export declare function evaluatePropertyValue<T extends InternalValueRepresentation>(property: PropertyAssignment, evaluationContext: EvaluationContext, wrapperFactories: WrapperFactoryProvider, valueType: ValueType<T>): T | undefined;
export declare function evaluateExpression(expression: Expression | undefined, evaluationContext: EvaluationContext, wrapperFactories: WrapperFactoryProvider, context?: ValidationContext | undefined, strategy?: EvaluationStrategy): InternalValueRepresentation | undefined;
