import { type ValidationContext } from '../../../validation/validation-context';
import { type BinaryExpression } from '../../generated/ast';
import { type WrapperFactoryProvider } from '../../wrappers';
import { type ValueType, type ValueTypeProvider } from '../../wrappers/value-type';
import { type BinaryOperatorTypeComputer } from '../operator-type-computer';
export declare class InOperatorTypeComputer implements BinaryOperatorTypeComputer {
    protected readonly valueTypeProvider: ValueTypeProvider;
    protected readonly wrapperFactories: WrapperFactoryProvider;
    private readonly ALLOWED_LEFT_OPERAND_TYPES;
    private readonly ALLOWED_RIGHT_OPERAND_TYPES;
    constructor(valueTypeProvider: ValueTypeProvider, wrapperFactories: WrapperFactoryProvider);
    computeType(leftOperandType: ValueType, rightOperandType: ValueType, expression: BinaryExpression, context: ValidationContext | undefined): ValueType | undefined;
}
