import { type DiagnosticInfo } from 'langium';
import { type BlockDefinition, type BlockTypePipeline, type PipeDefinition } from '../generated/ast';
import { type AstNodeWrapper } from './ast-node-wrapper';
export declare class PipeWrapper<T extends PipeDefinition | BlockTypePipeline = PipeDefinition | BlockTypePipeline> implements AstNodeWrapper<T> {
    readonly astNode: T;
    private readonly chainIndex;
    readonly from: BlockDefinition;
    readonly to: BlockDefinition;
    constructor(pipe: T, chainIndex: number);
    getFromDiagnostic(): DiagnosticInfo<PipeDefinition | BlockTypePipeline>;
    getToDiagnostic(): DiagnosticInfo<PipeDefinition | BlockTypePipeline>;
    equals(pipe: PipeWrapper<T>): boolean;
    static canBeWrapped(pipe: PipeDefinition | BlockTypePipeline, chainIndex: number): boolean;
}
