import { type Reference } from 'langium';
import { type OperatorEvaluatorRegistry } from '../../expressions/operator-registry';
import { type BuiltinConstrainttypeDefinition } from '../../generated/ast';
import { type ValueType, type ValueTypeProvider } from '../value-type';
import { type WrapperFactoryProvider } from '../wrapper-factory-provider';
import { type ExampleDoc, TypedObjectWrapper } from './typed-object-wrapper';
interface ConstraintDocs {
    description?: string;
    examples?: ExampleDoc[];
}
export declare class ConstraintTypeWrapper extends TypedObjectWrapper<BuiltinConstrainttypeDefinition> {
    docs: ConstraintDocs;
    readonly on: ValueType;
    /**
     * Creates a ConstraintTypeWrapper if possible. Otherwise, throws error.
     * Use {@link canBeWrapped} to check whether wrapping will be successful.
     *
     * Use {@link WrapperFactoryProvider} for instantiation instead of calling this constructor directly.
     */
    constructor(toBeWrapped: BuiltinConstrainttypeDefinition | Reference<BuiltinConstrainttypeDefinition>, operatorEvaluatorRegistry: OperatorEvaluatorRegistry, valueTypeProvider: ValueTypeProvider, wrapperFactories: WrapperFactoryProvider);
    static canBeWrapped(toBeWrapped: BuiltinConstrainttypeDefinition | Reference<BuiltinConstrainttypeDefinition>): boolean;
}
export {};
