import { type InternalValueRepresentation } from '../../expressions';
import { type ValueType, type ValueTypeVisitor } from './value-type';
export declare abstract class AbstractValueType<I extends InternalValueRepresentation> implements ValueType<I> {
    abstract acceptVisitor<R>(visitor: ValueTypeVisitor<R>): R;
    isSubtypeOf(other: ValueType): boolean;
    getSupertype(): ValueType | undefined;
    protected abstract doGetSupertype(): ValueType | undefined;
    abstract equals(target: ValueType): boolean;
    abstract isAllowedAsRuntimeParameter(): boolean;
    abstract isConvertibleTo(target: ValueType): boolean;
    isReferenceableByUser(): boolean;
    abstract isInternalValueRepresentation(operandValue: InternalValueRepresentation | undefined): operandValue is I;
    abstract getName(): string;
    hasSupertypeCycle(visited?: ValueType[]): boolean;
}
