import { type EvaluationContext } from '../../expressions/evaluation-context';
import { type InternalValueRepresentation } from '../../expressions/internal-value-representation';
import { type ConstraintDefinition, type ValuetypeDefinition } from '../../generated/ast';
import { type AstNodeWrapper } from '../ast-node-wrapper';
import { type WrapperFactoryProvider } from '../wrapper-factory-provider';
import { AbstractValueType } from './abstract-value-type';
import { type ValueTypeProvider } from './primitive';
import { type ValueType, type ValueTypeVisitor } from './value-type';
export declare class AtomicValueType extends AbstractValueType<InternalValueRepresentation> implements AstNodeWrapper<ValuetypeDefinition> {
    readonly astNode: ValuetypeDefinition;
    private readonly valueTypeProvider;
    private readonly wrapperFactories;
    constructor(astNode: ValuetypeDefinition, valueTypeProvider: ValueTypeProvider, wrapperFactories: WrapperFactoryProvider);
    acceptVisitor<R>(visitor: ValueTypeVisitor<R>): R;
    getConstraints(context: EvaluationContext): ConstraintDefinition[];
    isConvertibleTo(target: ValueType): boolean;
    isReferenceableByUser(): boolean;
    isAllowedAsRuntimeParameter(): boolean;
    getName(): string;
    protected doGetSupertype(): ValueType | undefined;
    isInternalValueRepresentation(operandValue: InternalValueRepresentation | undefined): operandValue is InternalValueRepresentation;
    equals(target: ValueType): boolean;
}
export declare function isAtomicValueType(v: unknown): v is AtomicValueType;
