import { type InternalValueRepresentation } from '../../../expressions';
import { type ValueType } from '../value-type';
import { BooleanValuetype } from './boolean-value-type';
import { CellRangeValuetype } from './cell-range-value-type';
import { CollectionValueType } from './collection/collection-value-type';
import { EmptyCollectionValueType } from './collection/empty-collection-value-type';
import { ConstraintValuetype } from './constraint-value-type';
import { DecimalValuetype } from './decimal-value-type';
import { IntegerValuetype } from './integer-value-type';
import { type PrimitiveValueType } from './primitive-value-type';
import { RegexValuetype } from './regex-value-type';
import { TextValuetype } from './text-value-type';
import { TransformValuetype } from './transform-value-type';
import { ValuetypeAssignmentValuetype } from './value-type-assignment-value-type';
/**
 * Should be created as singleton due to the equality comparison of primitive value types.
 * Exported for testing purposes.
 */
export declare class ValueTypeProvider {
    Primitives: PrimitiveValueTypeProvider;
    EmptyCollection: EmptyCollectionValueType;
    createCollectionValueTypeOf<I extends InternalValueRepresentation>(input: ValueType<I>): CollectionValueType<I>;
}
export declare class PrimitiveValueTypeProvider {
    Decimal: DecimalValuetype;
    Boolean: BooleanValuetype;
    Integer: IntegerValuetype;
    Text: TextValuetype;
    Regex: RegexValuetype;
    CellRange: CellRangeValuetype;
    Constraint: ConstraintValuetype;
    ValuetypeAssignment: ValuetypeAssignmentValuetype;
    Transform: TransformValuetype;
    getAll(): PrimitiveValueType[];
}
