import { type AstNodeDescription, type AstReflection, type IndexManager, type LangiumDocument, type LinkingErrorData, type MaybePromise } from 'langium';
import { type CodeActionProvider } from 'langium/lsp';
import { type CodeAction, type CodeActionParams, type Command, type Diagnostic, type Position } from 'vscode-languageserver-protocol';
import { type JayveeModel } from '../ast';
import { type JayveeServices } from '../jayvee-module';
export declare class JayveeCodeActionProvider implements CodeActionProvider {
    protected readonly reflection: AstReflection;
    protected readonly indexManager: IndexManager;
    constructor(services: JayveeServices);
    getCodeActions(document: LangiumDocument, params: CodeActionParams): MaybePromise<Array<Command | CodeAction>>;
    protected getCodeActionsForDiagnostic(diagnostic: Diagnostic, document: LangiumDocument): CodeAction[];
    protected getCodeActionsForLinkingError(diagnostic: Diagnostic, linkingData: LinkingErrorData, document: LangiumDocument): CodeAction[];
    protected getActionForImportCandidate(importCandidate: AstNodeDescription, diagnostic: Diagnostic, document: LangiumDocument): CodeAction | undefined;
    protected getImportLinePosition(javeeModel: JayveeModel): Position | undefined;
    private getRelativeImportPath;
}
