import { type AstNode, type LangiumDocuments, type LeafCstNode, type MaybePromise } from 'langium';
import { DefaultDefinitionProvider } from 'langium/lsp';
import { type DefinitionParams, LocationLink } from 'vscode-languageserver-protocol';
import { type JayveeServices } from '../jayvee-module';
import { type JayveeImportResolver } from '../services/import-resolver';
export declare class JayveeDefinitionProvider extends DefaultDefinitionProvider {
    protected documents: LangiumDocuments;
    protected importResolver: JayveeImportResolver;
    constructor(services: JayveeServices);
    protected collectLocationLinks(sourceCstNode: LeafCstNode, params: DefinitionParams): MaybePromise<LocationLink[] | undefined>;
    protected getLocationLink(sourceCstNode: LeafCstNode, jumpTarget: AstNode): LocationLink[] | undefined;
}
